local Me=CreateFrame("Frame","vZifnabsHUD")
vZifnabs.mod.hud=Me
local mod=vZifnabs.mod
local L={}
local db=nil
local hudtext={}
local hudix=0
local tick=0
local pushmsg=nil

-- -----------------------------------------------------------------
-- INITIALIZE
-- -----------------------------------------------------------------
function Me:Initialize()
	db=vZifnabsDB
	if not db.hud then db.hud={show=true} end
	L=vZifnabs.L
	
	widget={hud=getglobal("vZifnabs_HUD"),text=getglobal("vZifnabs_HUD_Text")}
	widget.text:SetFont("Fonts\\FRIZQT__.TTF", 20, "OUTLINE, MONOCHROME")
	mod.core:RegisterButton("hud","flip",L.button.hud.hide)
	mod.core:RegisterEvent("TICK","hud",Me.Tick)
	
	
end

-- -----------------------------------------------------------------
-- CLOCK
-- -----------------------------------------------------------------
function Me:Tick()
	if tick>0 or hudix>0 or pushmsg then
		local flip=math.floor((tick+1)/2)-math.floor(tick/2)
		widget.text:SetTextColor(1,1-flip,0,1)
	end

	if tick>0 then tick=tick-1
	elseif hudix>0 or pushmsg then
		if (db.hud.show) then
			if pushmsg then
				widget.text:SetText(pushmsg)
				pushmsg=nil
			else
				widget.text:SetText(hudtext[1])
				tremove(hudtext,1)
				hudix=hudix-1
			end
			widget.hud:Show()
		end
		if getn(hudtext)>1 then tick=20 else tick=40 end
	else
		widget.hud:Hide()
	end
end


-- -----------------------------------------------------------------
-- BUTTON
-- -----------------------------------------------------------------
function Me:Button(button,fnk)
	if fnk=="flip" then
		local flip2="show"
		if button.tooltipText==L.button.hud.show.tt then flip2="hide" end
		button:SetText(L.button.hud[flip2].text)
		button.tooltipText=L.button.hud[flip2].tt
		db.hud.show=(flip2=="hide")
	end
end


-- -----------------------------------------------------------------
-- 
-- -----------------------------------------------------------------
function Me:Write(text, soundname,push,chat)
	if soundname then PlaySound(soundname) end
	if chat or not push then mod.core:Print(text) end
	if push then 
		pushmsg=text
		tick=0
	else
		hudix=hudix+1
		hudtext[hudix]=text
		if tick>20 then tick=20 end
	end
end