local Me=CreateFrame("Frame","vZifnabsLocator")
vZifnabs.mod.locator=Me
local mod=vZifnabs.mod
local db=nil

local nr_of_zone={}
local zone_nr_next=1
local postext=nil

local FRACT=1000
local POS_MULTI=100*FRACT
local ZONE_MULTI=POS_MULTI*POS_MULTI

-- -----------------------------------------------------------------
-- INITIALIZE
-- -----------------------------------------------------------------
function Me:Initialize()
	db=vZifnabsDB
	mod.core:RegisterEvent("TICK","locator",Me.Tick)
	if not db.locator then db.locator={} end
	if not db.locator.zones then db.locator.zones={} end
	for nr,name in pairs(db.locator.zones) do
		nr_of_zone[name]=nr
		zone_nr_next=math.max(zone_nr_next,nr+1)
	end
	postext=getglobal("vZifnabs_LocatorPos_Text")
	postext:SetTextColor(1,1,1,1)
end

-- -----------------------------------------------------------------
-- CLOCK
-- -----------------------------------------------------------------
function Me:Tick()
	local x,y=Me:GetLoc()
	x=math.floor((100*x+5)/10)/10
	y=math.floor((100*y+5)/10)/10
	if not string.find(" "..x,"[.]") then x=x..".0" end
	if not string.find(" "..y,"[.]") then y=y..".0" end
	postext:SetText(x.." / "..y)
end

-- -----------------------------------------------------------------
-- GET LOCATION
-- -----------------------------------------------------------------
function Me:GetLoc()
	SetMapToCurrentZone()
	local zone=GetZoneText()
	local zone_nr=Me:GetZoneNr(zone)
	local x, y = GetPlayerMapPosition("player")
	x=math.min(POS_MULTI-1,math.floor(POS_MULTI*x+0.5))
	y=math.min(POS_MULTI-1,math.floor(POS_MULTI*y+0.5))
	return x/FRACT,y/FRACT,zone,ZONE_MULTI*zone_nr+POS_MULTI*x+y
end

-- -----------------------------------------------------------------
-- PARSE LOCATION NUMBER
-- -----------------------------------------------------------------
function Me:ParseLoc(loc)
	local zone_nr=math.floor(loc/ZONE_MULTI)
	loc=loc-zone_nr*ZONE_MULTI
	local x=math.floor(loc/POS_MULTI)
	local y=loc-x*POS_MULTI
	return x/FRACT,y/FRACT,db.locator.zones[zone_nr]
end

-- -----------------------------------------------------------------
-- GET ZONE NUMBER
-- -----------------------------------------------------------------
function Me:GetZoneNr(zone)
	local zone_nr=nr_of_zone[zone]
	if not zone_nr then
		zone_nr=zone_nr_next
		db.locator.zones[zone_nr]=zone
		nr_of_zone[zone]=zone_nr
		zone_nr_next=zone_nr_next+1
	end
	return zone_nr
end