local Me=CreateFrame("Frame","vZifnabsTargets")
vZifnabs.mod.targets=Me
local mod=vZifnabs.mod
local L={}
local db=nil

local widget={}
local delay=1
local resultlist=nil
local playername=UnitName("player")
local info_entry=nil
local damage_by_player=""


-- Slash Commands
SLASH_VZIFNABSTARGETS1 = "/zt"
SlashCmdList["VZIFNABSTARGETS"]=function (search) Me:Search(search) end

-- -----------------------------------------------------------------
-- INITIALIZE
-- -----------------------------------------------------------------
function Me:Initialize()
	db=vZifnabsDB
	L=vZifnabs.L
	
	if not db.targets then db.targets={enabled=true} end
	if not db.targets.seen then db.targets.seen={} end
	widget={frame=getglobal("vZifnabs_Targets"),text=getglobal("vZifnabs_Targets_Text"),
			cframe=getglobal("vZifnabs_Targets_CommentFrame"),ctext=getglobal("vZifnabs_Targets_CommentFrame_Text"),
			cup=getglobal("vZifnabs_Targets_Up"),cdown=getglobal("vZifnabs_Targets_Down"),
			sframe=getglobal("vZifnabs_Targets_SearchFrame"),stext=getglobal("vZifnabs_Targets_SearchFrame_Text"),
			}
	
	mod.core:RegisterButton("targets","reshow",L.button.targets.reshow)
	mod.core:RegisterButton("targets","search",L.button.targets.search)
	mod.core:RegisterButton("targets","hide",L.button.targets.hide,"vZifnabs_Targets_Hide")
	mod.core:RegisterButton("targets","up",L.button.targets.up,"vZifnabs_Targets_Up")
	mod.core:RegisterButton("targets","down",L.button.targets.down,"vZifnabs_Targets_Down")
	mod.core:RegisterButton("targets","edit",L.button.targets.comment,"vZifnabs_Targets_Comment")
	mod.core:RegisterButton("targets","save",L.button.targets.save,"vZifnabs_Targets_CommentFrame_Save")
	mod.core:RegisterButton("targets","abort",L.button.targets.abort,"vZifnabs_Targets_CommentFrame_Abort")
	mod.core:RegisterButton("targets","srun",L.button.targets.srun,"vZifnabs_Targets_SearchFrame_Run")
	mod.core:RegisterButton("targets","sabort",L.button.targets.sabort,"vZifnabs_Targets_SearchFrame_Abort")

	mod.core:RegisterEvent("PLAYER_TARGET_CHANGED","targets",Me.PLAYER_TARGET_CHANGED)
	mod.core:RegisterEvent("CHAT_MSG_COMBAT_FRIENDLY_DEATH","targets",Me.DEATH)
	mod.core:RegisterEvent("CHAT_MSG_COMBAT_HOSTILEPLAYER_HITS","targets",Me.COMBAT)
	mod.core:RegisterEvent("CHAT_MSG_SPELL_HOSTILEPLAYER_DAMAGE","targets",Me.COMBAT)
	mod.core:RegisterEvent("CHAT_MSG_SPELL_PERIODIC_SELF_DAMAGE","targets",Me.COMBAT)
	mod.core:RegisterEvent("PLAYER_REGEN_DISABLED","target",Me.COMBAT_START)
	mod.core:RegisterEvent("PLAYER_REGEN_ENABLED","target",Me.COMBAT_END)

	mod.core:RegisterEvent("CLOCK","targets",Me.Clock)
	
	
end

-- -----------------------------------------------------------------
-- CLOCK
-- -----------------------------------------------------------------
function Me:Clock()
	if not UnitExists("target") and delay>0 then
		delay=delay-1
		if delay==0 then widget.frame:Hide() end
	end
end

-- -----------------------------------------------------------------
-- BUTTON
-- -----------------------------------------------------------------
function Me:Button(button,fnk)
	if fnk=="hide" and resultlist then 
		resultlist=nil
		widget.cdown:Hide()
		widget.cup:Hide()
		button:SetText(L.button.targets.hide.text)
		button.tooltipText=L.button.targets.hide.tt
	elseif fnk=="hide" then
		widget.frame:Hide()
		db.targets.enabled=false
	elseif fnk=="reshow" then 
		widget.frame:Show()
		db.targets.enabled=true
	elseif fnk=="up" and resultlist and  resultlist.ix>1 then
		Me:TargetInfo(resultlist.ix-1,true)
	elseif fnk=="down" and resultlist and resultlist.ix<resultlist.max then
		Me:TargetInfo(resultlist.ix+1,true)
	elseif fnk=="edit" and infoentry then
		widget.ctext:SetText(db.targets.seen[infoentry].comment or "")
		widget.cframe:Show()
		widget.sframe:Hide()
	elseif fnk=="save" then
		db.targets.seen[resultlist[resultlist.ix]].comment=widget.ctext:GetText()
		widget.cframe:Hide()
	elseif fnk=="abort" then
		widget.cframe:Hide()
	elseif fnk=="search" then
		widget.frame:Show()
		widget.sframe:Show()
		widget.cframe:Hide()
	elseif fnk=="sabort" then
		widget.sframe:Hide()
	elseif fnk=="srun" then
		widget.sframe:Hide()
		Me:Search(widget.stext:GetText())
	end
end

-- -----------------------------------------------------------------
-- TARGET CHANGED
-- -----------------------------------------------------------------
function Me:PLAYER_TARGET_CHANGED()
	local name=UnitName("target")
	if UnitExists("target") and name~=playername and name~=UnitName("pet") then
		local lclass,class=UnitClass("target")
		local lrace,race=UnitRace("target")
		local family=UnitCreatureFamily("target")
		local faction=UnitFactionGroup("target")
		local guild=GetGuildInfo("target")
		local sex=UnitSex("target")
		local lvl=UnitLevel("target")
		local classify=UnitClassification("target")
		if classify=="normal" then classify=nil end
		local x,y,zone,pos=mod.locator:GetLoc()
		if not db.targets.seen[name] then db.targets.seen[name]={} end
		local first=db.targets.seen[name].first or time()
		local kills=db.targets.seen[name].kills
		local comment=db.targets.seen[name].comment
		db.targets.seen[name]={npc=(not UnitIsPlayer("target")),first=first,last=time(),pos=pos,lvl=lvl,faction=faction,classify=classify,class=class,race=race,family=family,sex=sex,guild=guild,kills=kills,comment=comment}
		if db.targets.enabled and not resultlist then Me:TargetInfo(name) end
	elseif not resultlist then delay=5
	end
end

-- -----------------------------------------------------------------
-- COMBAT START
-- -----------------------------------------------------------------
function Me:COMBAT_START()
	damage_by_player=""
end

-- -----------------------------------------------------------------
-- COMBAT END
-- -----------------------------------------------------------------
function Me:COMBAT_END()
	damage_by_player=""
end

-- -----------------------------------------------------------------
-- DEATH
-- -----------------------------------------------------------------
function Me:DEATH(event,arg1)
	if string.lower(arg1)==L.keyword.youdie and damage_by_player~="" then
		local x,y,zone,pos=mod.locator:GetLoc()
		local enemyfaction=L.keyword.HORDE
		if UnitFactionGroup("player")==enemyfaction then enemyfaction=L.keyword.ALLIANCE end
	
		local list=mod.core:Split(mod.core:Trim(damage_by_player)," ")
		mod.core:Print("died from "..damage_by_player.." ("..getn(list).." players)")		
		for nr=1,getn(list),1 do
			local enemy=list[nr]
			if not db.targets.seen[enemy] then db.targets.seen[enemy]={first=time(),npc=false,faction=enemyfaction} end
			db.targets.seen[enemy].last=time()
			db.targets.seen[enemy].pos=pos
			if not db.targets.seen[enemy].kills then db.targets.seen[enemy].kills={} end
			if not db.targets.seen[enemy].kills[playername] then db.targets.seen[enemy].kills[playername]={} end
			db.targets.seen[enemy].kills[playername][time()]=true
			local count=0
			for tm,dummy in pairs(db.targets.seen[enemy].kills[playername]) do
				count=count+1
			end
			mod.core:Print(mod.core:Repl(L.msg.killedby,{"<enemy>","<times>"},{enemy,count}))
		end
	end
end

-- -----------------------------------------------------------------
-- COMBAT DAMAGE
-- -----------------------------------------------------------------
function Me:COMBAT(event,arg1,arg2,arg3,arg4)
	local lowarg1=string.lower(arg1)
	if string.find(" "..lowarg1,L.keyword.ByouB) then
		local hostile=nil
		if event=="CHAT_MSG_COMBAT_HOSTILEPLAYER_HITS" then hostile=mod.core:Split(arg1," ",2)
		elseif event=="CHAT_MSG_SPELL_HOSTILEPLAYER_DAMAGE" then hostile=mod.core:Split(arg1,"'",2)
		elseif event=="CHAT_MSG_SPELL_PERIODIC_SELF_DAMAGE" then
			local from=string.find(lowarg1,L.keyword.BfromB) --You suffer nn from hostile's spell
			if string.find(lowarg1,L.keyword.youabsorb) then hostile=mod.core:Split(string.sub(arg1,string.len(L.keyword.youabsorb)+2),"'",2)
			elseif string.find(lowarg1,L.keyword.yougain) then hostile=nil
			elseif from then hostile=mod.core:Split(string.sub(arg1,from+string.len(L.keyword.BfromB)),"'",2)
			elseif not string.find(arg1,L.keyword.afflicted) then mod.core:Print("INTERNAL ERROR WITH '"..arg1.."'")
			end
		end
		
		if hostile then
			hostile=hostile[1]
			if db.targets.seen[hostile] then
				if db.targets.seen[hostile].npc or db.targets.seen[hostile].faction==UnitFactionGroup("player") then hostile=hil end
			end
			if hostile then
				mod.core:Print(mod.core:Repl(L.msg.damageby,"<enemy>",hostile))
				if not string.find(" "..damage_by_player.." "," "..hostile.." ") then damage_by_player=damage_by_player.." "..hostile end
			end
		end
	end
end

-- -----------------------------------------------------------------
-- TARGET INFO
-- -----------------------------------------------------------------
function Me:TargetInfo(entry,locinfo)
	delay=-1
	if type(entry)=="number" then
		resultlist.ix=entry
		if entry>1 then widget.cup:Show() else widget.cup:Hide() end
		if entry<resultlist.max then widget.cdown:Show() else widget.cdown:Hide() end
		entry=resultlist[entry]
	else
		widget.cdown:Hide()
		widget.cup:Hide()
	end

	info_entry=entry
	local info=db.targets.seen[entry]
	local report=entry
	if info.faction then report=report..", "..info.faction end
	if info.guild then report=report..", "..info.guild end
	report=report.."\n"..(info.class or "no class")
	if info.family then report=report..", "..info.family end
	if info.race then report=report..", "..info.race end
	if not info.lvl or info.lvl==-1 then report=report..", Lvl ??" else report=report..", Lvl "..info.lvl end
	if info.classify then report=report.." ("..info.classify..")" end
	if locinfo then 
		local x,y,zone=mod.locator:ParseLoc(info.pos)
		report=report.."\n"..date("%d.%m.%y, %H:%M:%S",math.floor(info.last)).."\n"..zone.." ("..x.." / "..y..")"
	end
	if info.kills then
		local killed=0
		local killedchar=0
		for name,list in pairs(info.kills) do
			for tm,dummy in pairs(list) do
				mod.core:Print(entry.." killed "..name..": "..date("%d.%m.%y, %H:%M:%S",tm))
				killed=killed+1
				if name==playername then killedchar=killedchar+1 end
			end
		end
		report=report.."\n"..mod.core:Repl(L.msg.killreport,{"<times>","<alltimes>"},{killedchar,killed})
	end
	if info.comment then report=report.."\n"..info.comment end
	if resultlist then report=resultlist.ix.."/"..resultlist.max..": "..report end
	widget.text:SetText(report)
	widget.frame:Show()
	widget.cframe:Hide()
end

-- -----------------------------------------------------------------
-- SEARCH
-- -----------------------------------------------------------------
function Me:Search(what)
	local selector={}
	while what do
		local split=mod.core:Split(what," ",2)
		local word=string.lower(mod.core:Trim(split[1]))
		if word=="player" then selector.ctype="player"
		elseif word=="npc" then selector.ctype="npc"
		elseif word=="kills" then selector.kills=true
		elseif word=="horde" then selector.faction="HORDE"
		elseif word=="ally" then selector.faction="ALLIANCE"
		else break
		end
		what=mod.core:Trim(split[2])
	end
	list={}
	local nr=0
	local dbsize=0
	local kills={}
	for name,info in pairs(db.targets.seen) do
		dbsize=dbsize+1
		local take=true		
		if selector.ctype=="player" and info.npc then take=false
		elseif selector.ctype=="npc" and not info.npc then take=false
		elseif selector.kills and (not info.kills or not info.kills[playername]) then take=false
		elseif selector.faction and selector.faction~=info.faction then take=false
		elseif what and not string.find(string.lower(name.." "..(info.guild or "").." "..(info.class or "").." "..(info.race or "")),what) then take=false
		end

		if take then 
			nr=nr+1
			if not list[info.last] then list[info.last]={} end
			list[info.last][1+getn(list[info.last])]=name
			if selector.kills and info.kills and info.kills[playername] then
				for datetime,dummy in pairs(info.kills[playername]) do
					kills[datetime]=true
				end
			end
		end
	end
	if nr==0 then resultlist=nil
	else
		resultlist={ix=1,max=nr}
		table.sort(list)
		for datetimesequence,info in pairs(list) do
			for ix=1,getn(info),1 do
				resultlist[nr]=info[ix]
				nr=nr-1
			end
		end
		local button=getglobal("vZifnabs_Targets_Hide")
		button:SetText(L.button.targets.hides.text)
		button.tooltipText=L.button.targets.hides.tt
		Me:TargetInfo(1,true)
	end
end